package edu.uoc.sm.contactdb.actions;

import edu.uoc.pfc.sm.annotation.ErrorDestination;
import edu.uoc.pfc.sm.annotation.Forward;
import edu.uoc.pfc.sm.annotation.SMControllerBean;
import edu.uoc.pfc.sm.annotation.ValidateBean;
import edu.uoc.pfc.sm.annotation.ValidateMethod;
import edu.uoc.sm.contactdb.dao.CircleDAO;
import edu.uoc.sm.contactdb.dao.ContactDAO;
import edu.uoc.sm.contactdb.data.CircleData;
import java.util.List;

/**
 *
 * @author Salvador Morla
 */

public class Contact {
    
    @SMControllerBean
    @ValidateBean
    edu.uoc.sm.contactdb.data.ContactData contact;
    
    @SMControllerBean (requestSetAttribute=false)
    Integer contactId ;
    
    @SMControllerBean (requestGetParameter=false, create=false)
    Integer contactIdToReload;
    
    @SMControllerBean (requestGetParameter=false)
    List<CircleData> circleList;
    /**
     * Obte la llista de contactes del sistema.
     */
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")    
    public void find() throws Exception {
        ContactDAO contactDao = ContactDAO.getDAO();
        if (contactId != null) {
            contact = contactDao.find(contactId);
        }
        else {
            throw new Exception("Id not found!");
        }
        
        getViewAdditionalData();
    }
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    @ValidateMethod  (errorView= "/error/ContactValidationError.jsp")
    public void update() throws Exception {
        ContactDAO contactDao = ContactDAO.getDAO();
        
        contactDao.update(contact);
        
        this.contactIdToReload = contact.getId();
    }
    
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    @ValidateMethod  (errorView= "/error/ContactValidationError.jsp")
    public void insert() throws Exception {
        ContactDAO contactDao = ContactDAO.getDAO();      
        contactDao.insert(contact);
        
        getViewAdditionalData();
    }
    
    
    private void getViewAdditionalData() {
        CircleDAO circleDAO = CircleDAO.getDAO();
        circleList = circleDAO.findAll();
    }
}
