package edu.uoc.sm.contactdb.actions;

import edu.uoc.pfc.sm.annotation.ErrorDestination;
import edu.uoc.pfc.sm.annotation.Forward;
import edu.uoc.pfc.sm.annotation.SMControllerBean;
import edu.uoc.sm.contactdb.dao.ContactDAO;

/**
 *
 * @author Salvador Morla
 */

public class ContactCircle {
    
    @SMControllerBean (requestSetAttribute=false)
    Integer contactId ;
    
    @SMControllerBean (requestSetAttribute=false)
    Integer circleId;
    
    @SMControllerBean (requestGetParameter=false, create=false)
    Integer contactIdToReload;
    
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void addCircle() throws Exception {
        ContactDAO contactDao = ContactDAO.getDAO();
        contactDao.addCircle(contactId, circleId);
        
        this.contactIdToReload = contactId;
    }
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void removeCircle() throws Exception {
        ContactDAO contactDao = ContactDAO.getDAO();
        contactDao.removeCircle(contactId, circleId);
        
        this.contactIdToReload = contactId;
    }
}
