package edu.uoc.sm.contactdb.actions;

import edu.uoc.pfc.sm.annotation.ErrorDestination;
import edu.uoc.pfc.sm.annotation.Forward;
import edu.uoc.pfc.sm.annotation.SMControllerBean;
import edu.uoc.sm.contactdb.dao.ContactDAO;
import java.util.List;

/**
 * Action que recupera la llista de contactes.
 * 
 * @author Salvador Morla
 * @version 1.0
 */

public class ContactList {
    
    // Definim un SMControllerBean en el que tornam la llista de contactes.
    // Indicam que la llista no ve com parametre.
    @SMControllerBean(requestGetParameter=false) 
    List<edu.uoc.sm.contactdb.data.ContactData> contactList;
            
    /**
     * Obte la lista de contactes del sistema.
     */
    @Forward         ("/jsp/ContactList.jsp") // Especificam la vista a mostrar
    @ErrorDestination("/error/error.jsp")     // Especificam la vista de error
    public void execute() throws Exception {        
        ContactDAO contactDao = ContactDAO.getDAO();
        contactList = contactDao.findAll();        
    }
}
