package edu.uoc.sm.contactdb.actions;

import edu.uoc.pfc.sm.annotation.ErrorDestination;
import edu.uoc.pfc.sm.annotation.Forward;
import edu.uoc.pfc.sm.annotation.SMControllerBean;
import edu.uoc.pfc.sm.annotation.ValidateBean;
import edu.uoc.pfc.sm.annotation.ValidateMethod;
import edu.uoc.sm.contactdb.dao.EmailAccountDAO;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Salvador Morla
 */

public class EmailAccount {
    
    @SMControllerBean
    @ValidateBean
    edu.uoc.sm.contactdb.data.EmailAccountData emailAccount;
    
    @SMControllerBean (requestGetParameter=false)
    List<String> emailAccountLabelList;
    
    @SMControllerBean (requestGetParameter=false)
    Integer contactIdToReload;

    /**
     * Obte la el telefon del de emailAccounte.
     */
    @Forward         ("/jsp/EmailAccountForm.jsp")
    @ErrorDestination("/error/error.jsp")
    
    public void find() throws Exception {
        EmailAccountDAO emailAccountDao = EmailAccountDAO.getDAO();
        if (emailAccount.getContactId() != null && emailAccount.getEmailAccount() != null) {
            emailAccount = emailAccountDao.find(emailAccount.getContactId(), emailAccount.getEmailAccount());
        }
        else {
            throw new Exception("Id not found!");
        }
        // Carregam altres objectes necessaris per la vista.
        getEmailAccountLabelList();
    }
    
    @Forward         ("/jsp/EmailAccountForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void newEmailAccount() throws Exception {
        getEmailAccountLabelList();
               
    }
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    @ValidateMethod  (errorView= "/error/EmailAccountValidationError.jsp")
    public void save() throws Exception {
        EmailAccountDAO emailAccountDao = EmailAccountDAO.getDAO();      
        emailAccountDao.processEmailAccount(emailAccount);
        
        contactIdToReload = emailAccount.getContactId();
    }
    
    
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void delete() throws Exception {
        EmailAccountDAO emailAccountDao = EmailAccountDAO.getDAO();
        // Asignam l'id al bean per tenirlo disponible per al retorn.
        contactIdToReload = emailAccount.getContactId();
        // Executam l'eliminaci
        emailAccountDao.delete(emailAccount.getContactId(), emailAccount.getEmailAccount());        
    }
    
    
    private void getEmailAccountLabelList() {
        // Se suposa una cridada a un mtode de negoci
        // Pero per simplicar se crea una llista de valors
        List<String> l = new ArrayList<String>();
        l.add("Personal");
        l.add("Work");
        l.add("Personal");
        
        this.emailAccountLabelList = l;
    }
}
