package edu.uoc.sm.contactdb.actions;

import edu.uoc.pfc.sm.annotation.ErrorDestination;
import edu.uoc.pfc.sm.annotation.Forward;
import edu.uoc.pfc.sm.annotation.SMControllerBean;
import edu.uoc.pfc.sm.annotation.ValidateBean;
import edu.uoc.pfc.sm.annotation.ValidateMethod;
import edu.uoc.sm.contactdb.dao.PhoneDAO;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Salvador Morla
 */

public class Phone {
    
    @SMControllerBean
    @ValidateBean
    edu.uoc.sm.contactdb.data.PhoneData phone;
    
    @SMControllerBean (requestGetParameter=false)
    List<String> phoneLabelList;
    
    @SMControllerBean (requestGetParameter=false)
    Integer contactIdToReload;

    /**
     * Obte la el telefon del de phonee.
     */
    @Forward         ("/jsp/PhoneForm.jsp")
    @ErrorDestination("/error/error.jsp")
    
    public void find() throws Exception {
        PhoneDAO phoneDao = PhoneDAO.getDAO();
        if (phone.getContactId() != null && phone.getPhoneNumber() != null) {
            phone = phoneDao.find(phone.getContactId(), phone.getPhoneNumber());
        }
        else {
            throw new Exception("Id not found!");
        }
        // Carregam altres objectes necessaris per la vista.
        getPhoneLabelList();
    }
    
    @Forward         ("/jsp/PhoneForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void newPhone() throws Exception {
        getPhoneLabelList();
               
    }
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    @ValidateMethod  (errorView= "/error/PhoneValidationError.jsp")
    public void save() throws Exception {
        PhoneDAO phoneDao = PhoneDAO.getDAO();      
        phoneDao.processPhone(phone);
        
       contactIdToReload = phone.getContactId();
    }
    
    
    
    @Forward         ("/jsp/ContactForm.jsp")
    @ErrorDestination("/error/error.jsp")
    public void delete() throws Exception {
        PhoneDAO phoneDao = PhoneDAO.getDAO();
        // Asignam l'id al bean per tenirlo disponible per al retorn.
        contactIdToReload = phone.getContactId();
        // Executam l'eliminaci
        phoneDao.delete(phone.getContactId(), phone.getPhoneNumber());        
    }
    
    
    private void getPhoneLabelList() {
        // Se suposa una cridada a un mtode de negoci
        // Pero per simplicar se crea una llista de valors
        List<String> l = new ArrayList<String>();
        l.add("Cell");
        l.add("Home");
        l.add("Office");
        l.add("Personal");
        
        this.phoneLabelList = l;
    }
}
