package edu.uoc.sm.contactdb.dao;

import edu.uoc.sm.contactdb.data.CircleData;
import java.util.ArrayList;
import java.util.List;

/**
 * Data Access Object for CircleData
 * 
 * @author Salvador Morla
 * @version 1.0
 * 
 */
public class CircleDAO {
    
    private int nextId;
    private List<CircleData> list;
    private static CircleDAO singleton;
    
    
    public static CircleDAO getDAO() {
        if(singleton == null) { singleton = new CircleDAO(); }
        return singleton;
    }
    
    private CircleDAO() {
        this.nextId = 0;
        this.list = new ArrayList<CircleData>();
        init();
    }
    
    
    public List<CircleData> findAll() {
        return this.list;
    }
    
    
    public CircleData find(Integer id) {
        CircleData c = null;
        for (CircleData caux : this.list) {
            if (caux.getId().intValue() == id.intValue()) {
                c = caux;
                break;
            }
        }
        return c;
    }
    
    
    
    private void init() {
        CircleData c;
               
        c = new CircleData();
        c.setId(++nextId);
        c.setName("Friends");                
        list.add(c);
        
        c = new CircleData();
        c.setId(++nextId);
        c.setName("Family");              
        list.add(c);
        
        c = new CircleData();
        c.setId(++nextId);
        c.setName("Acquaintances");
        list.add(c);
        
        c = new CircleData();
        c.setId(++nextId);
        c.setName("Work");      
        list.add(c);        
    }
    
    

}