package edu.uoc.sm.contactdb.dao;

import edu.uoc.sm.contactdb.data.ContactData;
import edu.uoc.sm.contactdb.data.EmailAccountData;

/**
 * Data Access Object for EmailAccountData
 * 
 * @author Salvador Morla
 * @version 1.0
 * 
 */
public class EmailAccountDAO {
    
    private static EmailAccountDAO singleton;
    
    public static EmailAccountDAO getDAO() {
        if(singleton == null) { singleton = new EmailAccountDAO(); }
        return singleton;
    }
    
    private EmailAccountDAO() {
    }
    
    
    public void processEmailAccount(EmailAccountData e) throws Exception {
        ContactData c = getContactDAO().find(e.getContactId());
        if (c != null) {
            // Update phone
            EmailAccountData paux = this.find(e.getContactId(), e.getEmailAccount());
            if (paux != null) {
                paux.setEmailAccountName(e.getEmailAccountName());
            }
            else {
                // Insert phone
                c.getEmailAccountList().add(e);
            }
        }
        else {
            throw new Exception("Unexpected error.");
        }
    }
    
    
    public EmailAccountData find(Integer contactId, String  email) throws Exception {
        
        ContactData c = getContactDAO().find(contactId);
        EmailAccountData p = null;
        if (c != null) {
            for(int i=0; i < c.getEmailAccountList().size(); i++) {
                if(email.equals(c.getEmailAccountList().get(i).getEmailAccount())) {                
                    p = c.getEmailAccountList().get(i);
                }
            }
        }
        else {
            throw new Exception("Unexpected error.");
        }
        return p;
    }
    
    public void delete(Integer contactId, String  phonenumber) {
        
        ContactData c = getContactDAO().find(contactId);
        if (c != null) {
            for(int i=0;i<c.getEmailAccountList().size();i++) {
                if(c.getEmailAccountList().get(i).getEmailAccount().equals(phonenumber)) {
                    c.getEmailAccountList().remove(i);
                    break;
                }
            }
        }
    }
    
    private ContactDAO getContactDAO() {
        return ContactDAO.getDAO();
    }
}