package edu.uoc.sm.contactdb.dao;

import edu.uoc.sm.contactdb.data.ContactData;
import edu.uoc.sm.contactdb.data.PhoneData;

/**
 * Data Access Object for PhoneData
 * 
 * @author Salvador Morla
 * @version 1.0
 * 
 */
public class PhoneDAO {
    
    private static PhoneDAO singleton;
    
    public static PhoneDAO getDAO() {
        if(singleton == null) { singleton = new PhoneDAO(); }
        return singleton;
    }
    
    private PhoneDAO() {
    }
    
    
    public void processPhone(PhoneData p) throws Exception {
        ContactData c = getContactDAO().find(p.getContactId());
        if (c != null) {
            // Update phone
            PhoneData paux = this.find(p.getContactId(), p.getPhoneNumber());
            if (paux != null) {
                paux.setPhoneName(p.getPhoneName());
            }
            else {
                // Insert phone
                c.getPhonesList().add(p);
            }
        }
        else {
            throw new Exception("Unexpected error.");
        }
    }
    
    
    public PhoneData find(Integer contactId, String  phonenumber) throws Exception {
        
        ContactData c = getContactDAO().find(contactId);
        PhoneData p = null;
        if (c != null) {
            for(int i=0; i < c.getPhonesList().size(); i++) {
                if(phonenumber.equals(c.getPhonesList().get(i).getPhoneNumber())) {                
                    p = c.getPhonesList().get(i);
                }
            }
        }
        else {
            throw new Exception("Unexpected error.");
        }
        return p;
    }
    
    public void delete(Integer contactId, String  phonenumber) {
        
        ContactData c = getContactDAO().find(contactId);
        if (c != null) {
            for(int i=0;i<c.getPhonesList().size();i++) {
                if(c.getPhonesList().get(i).getPhoneNumber().equals(phonenumber)) {
                    c.getPhonesList().remove(i);
                    break;
                }
            }
        }
    }
    
    private ContactDAO getContactDAO() {
        return ContactDAO.getDAO();
    }
}