package edu.uoc.sm.contactdb.data;

import edu.uoc.pfc.sm.annotation.FieldValidation;
import edu.uoc.pfc.sm.data.Data;

/**
 * Represents an email account 
 * 
 * @author Salvador Morla
 * @version 1.0
 */
public class EmailAccountData extends Data {
    
    // Contact id
    @FieldValidation (type="PositiveInteger", notNull=true)
    private Integer contactId;
    
    // Email account
    @FieldValidation (type="EmailAddress", maxLength=50, notNull=true)
    private String emailAccount;
    
    // Contact element name: personal, work, cell
    @FieldValidation (type="TextString", maxLength=25, notNull=true)
    private String emailAccountName;
    

    /**
     * @return the contactId
     */
    public Integer getContactId() {
        return contactId;
    }

    /**
     * @param contactId the contactId to set
     */
    public void setContactId(Integer contactId) {
        this.contactId = contactId;
    }

    /**
     * @return the emailAccount
     */
    public String getEmailAccount() {
        return emailAccount!=null?emailAccount:"";
    }

    /**
     * @param emailAccount the emailAccount to set
     */
    public void setEmailAccount(String emailAccount) {
        this.emailAccount = emailAccount;
    }

    /**
     * @return the emailAccountName
     */
    public String getEmailAccountName() {
        return emailAccountName!=null?emailAccountName:"";
    }

    /**
     * @param emailAccountName the emailAccountName to set
     */
    public void setEmailAccountName(String emailAccountName) {
        this.emailAccountName = emailAccountName;
    }

    
}
