package edu.uoc.sm.contactdb.data;

import edu.uoc.pfc.sm.annotation.FieldValidation;
import edu.uoc.pfc.sm.data.Data;

/**
 * Represents a contact phone number.
 * 
 * @author Salvador Morla
 * @version 1.0
 */
public class PhoneData extends Data {
    
    // Contact id
    @FieldValidation (type="NumericInteger", notNull=true)
    private Integer contactId;
    
    // PhoneData number
    @FieldValidation (type="AlfanumericIdentifier", maxLength=10, notNull=true)
    private String phoneNumber;
    
    // PhoneData number name: personal, work, cell
    @FieldValidation (type="TextString", maxLength=15, notNull=true)
    private String phoneName;

    /**
     * @return the phoneNumber
     */
    public String getPhoneNumber() {
        return phoneNumber!=null?phoneNumber:"";
    }

    /**
     * @param phoneNumber the phoneNumber to set
     */
    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    /**
     * @return the phoneName
     */
    public String getPhoneName() {
        return phoneName;
    }

    /**
     * @param phoneName the phoneName to set
     */
    public void setPhoneName(String phoneName) {
        this.phoneName = phoneName;
    }

    /**
     * @return the contactId
     */
    public Integer getContactId() {
        return contactId;
    }

    /**
     * @param contactId the contactId to set
     */
    public void setContactId(Integer contactId) {
        this.contactId = contactId;
    }
}
