package edu.uoc.pfc.sm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/*
 * Indica al controlador que quan se produexi un error en l'execució s'ha 
 * de redirigir la navegació a la vista indicada per paràmetre.
 * 
 * @Author Salvador Morla
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.METHOD})
public @interface ErrorDestination {
    /* 
     * Paràmetre obligatori que especifica la vista de destí on se processarà
     * l'error.
     */
    String value();
    /* Moficador del comportament. Per defecte sempre se farà forward, pero 
     * si s'activa a true aquesta propietat, se farà redirect.
     */
    boolean redirect() default false;
}
