package edu.uoc.pfc.sm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Indica al controlador que quan acabi l'execució que processa la petició 
 * s'ha de redirigir la navegació a la vista indicada per paràmetre 
 * mitjançant redirect.
 * 
 * @author Salvador Morla
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.METHOD})
public @interface Redirect {
    // Paràmetre obligatori que especifica la vista de destí
    String value();
}
