package edu.uoc.pfc.sm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Especifica la llista de rols que tendran acces a l'execucio d'un metode
 * d'una classe de component de controlador Action. Per indicar varis rols
 * se fa com a l'exemple seguent: {"rol_a", "rol_b, ...}
 * 
 * @author Salvador Morla
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.METHOD})
public @interface RolesAllowed {
    /* Llista de rols als que se dona accés al mètode o classe */
    String[] value();
}
