package edu.uoc.pfc.sm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.FIELD)
@Retention(RetentionPolicy.RUNTIME)
public @interface SMControllerBean {
    /** 
     * Especifica si el controlador ha de crear o no l'objecte anotat. Per 
     * defecte s'especifica a true. Si se possa a false voldrà dir que 
     * la creació de l'objecte serà responsabilitat de la pròpia Action. 
     */
    boolean create() default true;
    /**
     * Indicador de si l'objecte s'ha d'inicialitzar a partir de la informació
     * que se recull dels paràmetres del request.
     */
    boolean requestGetParameter() default true;
    /**
     * Indicador que el 
     * @return 
     */
    boolean requestSetAttribute() default true;
}
