package edu.uoc.pfc.sm.beanutils.converter;

import edu.uoc.pfc.sm.util.Constants;
import java.math.BigDecimal;
import org.apache.commons.beanutils.Converter;

public class NumberConverter implements Converter {

    private static NumberConverter instance = new NumberConverter();

    private NumberConverter() {
        super();
    }

    public static NumberConverter getInstance() {
        return instance;
    }

    @Override
    public Object convert(Class type, Object value) {
        try {
            if (value instanceof String) {
                String s = (String) value;
                if (type.equals(Integer.class)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Integer(s) : null;
                } else if (type.equals(Integer.TYPE)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Integer(s) : new Integer(Constants.DEFAULT_INT);
                } else if (type.equals(Long.class)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Long(s) : null ;
                } else if (type.equals(Long.TYPE)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Long(s) : new Long(Constants.DEFAULT_LONG);               
                } else if (type.equals(Float.class)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Float(s) : null ;
                } else if (type.equals(Float.TYPE)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Float(s) : new Float(Constants.DEFAULT_FLOAT);
                } else if (type.equals(Double.class)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Double(s) : null ;
                } else if (type.equals(Double.TYPE)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new Double(s) : new Double(Constants.DEFAULT_DOUBLE);
                } else if (type.equals(BigDecimal.class)) {
                    return (s != null && !s.equals(Constants.EMPTY_STRING)) ? new BigDecimal(s) : null;
                } else {
                    /* No set pot convertir el parametre http al tipus perque no en sabem */
                    return null;
                }
            } else {
                /* No se pot convertir el parametre http al tipus perque no es un string */
                return null;
            }
        } catch (Exception e) {
            System.out.println("SMController Error. No se pot convertir el parametre http " + value + " al tipus " + type.getCanonicalName());
            return null;
        }
    }
}
