package edu.uoc.pfc.sm.error;

/**
 * Representa un error produit en l'execució de mètodes de classe Action.
 * 
 * @author Salvador Morla
 * @version 1.0
 */
public class ErrorActionMethodExecution extends SMControllerError{
    
    public ErrorActionMethodExecution(String fullyQualifiedClassName, String methodName, Exception ex) {
        super("S'ha produit un error executatant el metode de la Action " + fullyQualifiedClassName + "." + methodName + "()" 
                + ((ex != null && ex.getCause() != null && ex.getCause().getMessage().length() > 0) 
                  ? ": "+ex.getCause().getMessage() 
                  : "")
                , ex);
    }
}
