package edu.uoc.pfc.sm.error;

/**
 * Representa un error produit qun un usuari no te permissos per executar un 
 * mètode d'una classe action.
 * 
 * @author fros
 */
public class ErrorActionMethodNotAllowed extends SMControllerError{
    
    public ErrorActionMethodNotAllowed(String fullyQualifiedClassName, String methodName, IllegalAccessException ex) {
        super("Error. No té permissos per executar l'acció " + fullyQualifiedClassName + "." + methodName + "()", ex);
    }
    
    public ErrorActionMethodNotAllowed(String fullyQualifiedClassName, String methodName, SecurityException ex) {
        super("Error. No té permissos per executar l'acció " + fullyQualifiedClassName + "." + methodName + "()", ex);
    }
    
    public ErrorActionMethodNotAllowed(String fullyQualifiedClassName, String methodName) {
        super("Error. No té permissos per executar l'acció " + fullyQualifiedClassName + "." + methodName + "()");
    }
}
