package edu.uoc.pfc.sm.error;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * Classe principal de errors per SMController
 * @author Salvador Morla
 */
public abstract class SMControllerError extends Exception {
    
    public SMControllerError() {
        super();
    }
    
    public SMControllerError(String s) {
        super(s);
    }
    
    public SMControllerError(String s, Throwable t) {
        super(s,t);
    }
    
    public SMControllerError(Throwable t) {
        super(t);
    }
    
    
    
    /**
     * Genera el stacktrace en un string.
     */
    public static String stack2string(Throwable t) {
        try {
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            t.printStackTrace(pw);
            return sw.toString();
        } catch (Exception e2) {
            return "No s'ha pogut obtenir l'StackTrace: " + e2.toString();
        }
    }
}
