package edu.uoc.pfc.sm.validation;

/**
 * Classe que defineix com ha de ser una classe que implementa una validació.
 * 
 * @author Salvador Morla
 * @version 1.0
 */
public abstract class SMControllerValidationType {
    
    /* Valor a validar */
    private String value;
    /* Estableix la llargaria minima per a tipus alfanumerics. */
    private Integer minLength;
    /* Estableix la llargaria maxima per a tipus alfanumerics. */
    private Integer maxLength;
    /* Estableix la llargaria minima per a tipus numerics. */
    private Integer minValue;
    /* Estableix la llargaria maxima per a tipus numerics. */
    private Integer maxValue;
    /* Patró de validació */
    private String pattern;
    /* Indicador de no nul */
    private Boolean notNull;
    
    
    /**
     * @return the minLength
     */
    public Integer getMinLength() {
        return minLength;
    }

    /**
     * @param minLength the minLength to set
     */
    public void setMinLength(Integer minLength) {
        this.minLength = minLength;
    }

    /**
     * @return the maxLength
     */
    public Integer getMaxLength() {
        return maxLength;
    }

    /**
     * @param maxLength the maxLength to set
     */
    public void setMaxLength(Integer maxLength) {
        this.maxLength = maxLength;
    }

    /**
     * @return the minValue
     */
    public Integer getMinValue() {
        return minValue;
    }

    /**
     * @param minValue the minValue to set
     */
    public void setMinValue(Integer minValue) {
        this.minValue = minValue;
    }

    /**
     * @return the maxValue
     */
    public Integer getMaxValue() {
        return maxValue;
    }

    /**
     * @param maxValue the maxValue to set
     */
    public void setMaxValue(Integer maxValue) {
        this.maxValue = maxValue;
    }

    /**
     * @return the value
     */
    public String getValue() {
        return value;
    }

    /**
     * @param value the value to set
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * @return the pattern
     */
    public String getPattern() {
        return pattern;
    }

    /**
     * @param pattern the pattern to set
     */
    public void setPattern(String pattern) {
        this.pattern = pattern;
    }

    /**
     * @return the notNull
     */
    public Boolean getNotNull() {
        return notNull;
    }

    /**
     * @param notNull the notNull to set
     */
    public void setNotNull(Boolean notNull) {
        this.notNull = notNull;
    }
        
}
